/*
 * $Source$
 * $Author$
 * $Revision$
 *
 * (c)2000 Bram Stolk (b.stolk at host chello.nl)
 */

#include <string>
#include <map>
#include <set>


typedef std::set<std::string> stringset_t;


// This is what we know of a single header file

class HeaderInfo
{
  public:
    HeaderInfo() {}
    HeaderInfo(const std::string &fullnm);
    std::string fullname;       // header filename including path
    std::string shortname;      // header filename excluding path
    stringset_t deps;           // its dependencies on other headers
    stringset_t defs;           // the class defs it hosts
    stringset_t prunables;      // which deps should probably be dropped
};


// Here we map the names of the headerfiles onto information

typedef std::map<std::string, HeaderInfo> mapping_t;


class DepChecker
{
  public:
    DepChecker(std::string dn, std::string ext) : dirname(dn) , extention(ext) {}
    ~DepChecker() {}
    void BuildDb();
    void PrintNode
    (
      const std::string name, 
      const std::string indent, 
      const std::string prefix, 
      std::set<std::string> visited,
      std::set<std::string> &printed
    );
    void Print(void);
    void SearchForDeps(void);
    void SearchForDefs(void);
    void SearchForPrunables(void);
    bool IsRootNode(std::string name) const;

  protected:
    bool DirectUse(std::string user, std::string usedclass);
 
    std::string dirname;
    std::string extention;
    mapping_t mapping;
};

// $Log$
